MICROSOFT Coding Interview | Getting Interviewed by a Microsoft Engineer

SdĂ­let
VloĆŸit
  • čas pƙidĂĄn 26. 07. 2024
  • 🔮 Learn DSA - learnyard.com/courses/dsa
    Free premium articles - read.learnyard.com
    ..................................................................................
    Service Based To Google: ‱ Video
    🔮 Free Gifts from Crio www.crio.do/redeem/f062a88/
    🔮 Don't Click this! bit.ly/3GBAV7f
    🔮Watch the complete Linked List Series ‱ Linked List Series
    🔮Placement Preparation Roadmap ‱ Roadmaps for Placement
    🔮My contact details
    Instagram :- / frazmohammad
    Connect with me on LinkedIn :- / mohammad-f-bb4886157
    Telegram Group t.me/LeadCoding
    CZcams:
    / kushalvijay
    Instagram:
    / kushal_vijay_
    Linkedin:
    / kushalvijay
    Twitter:
    / kushalvijay_
    The video contains following parts-
    0:00-0:40 - Intro
    0:41-1:35 - Question 1
    1:36-4:01 - Question 1 discussion
    4:02-05:17 - Crio Sponsorship
    5:18-13:21 - Question 1 discussion
    13:22-16:58 - Question 1 Code
    17:00-17:46 - Question 2
    17:47-25:25 - Question 2 discussion
    25:26-35:56 - Question 2 code
    35:57-36:20- Closing Notes
    Hi, I am Fraz.
    I am Software Engineer working at Curefit and I love teaching.
    This is my Channel where I upload content related to Interviews and my personal experiences.
    ✹ Hashtags ✹
    #SoftwareEngineer #FAANGM #FAANG #DTU #engineering #internship #college #DSA #Freshers

Komentáƙe • 204

  • @arishsheikh3000
    @arishsheikh3000 Pƙed 2 lety +195

    It should be row++ instead of col++

  • @akshatmahajan2692
    @akshatmahajan2692 Pƙed 2 lety +15

    really helpful more similar videos would definitely boost the confidence before campus placements

  • @codencode5546
    @codencode5546 Pƙed 2 lety +52

    Sir first of all thanks to you and Kushal Sir to feel the Enviroment of a Real Interview and I can solve all the 2 Questions so I'm Happy that my Efforts are worth it!!

  • @subhamshaw7755
    @subhamshaw7755 Pƙed 5 měsĂ­ci +2

    we can also use a base case if(targ < a[0][0] || targ > a[n-1][n-1]) return false;

  • @devanshmesson2777
    @devanshmesson2777 Pƙed 2 lety +24

    Much needed videos like this!
    Just want to thank you for this!
    Telling the approach in an interview is a skill, thank you for guiding us about how to give an interview!

    • @mohammadfraz
      @mohammadfraz  Pƙed 2 lety +3

      Thanks a lot for appreciating â˜ș, hope it helps

  • @manojsv8252
    @manojsv8252 Pƙed rokem +6

    I think we can reduce the for loop iterations a bit in case we have many numbers by having a condition "nums[i]

  • @aakashshelake
    @aakashshelake Pƙed 2 měsĂ­ci +2

    You can treat whole matrix as 1d array
    Where low = 0, high = n * m - 1
    And do binary search
    We can find row and col like
    Mid/m , mid%m res.

  • @subhamengine1143
    @subhamengine1143 Pƙed 2 lety +1

    Just heard your approach and tried to code myself on LC, and it was correct in the first attempt.

  • @ahmedbahri5115
    @ahmedbahri5115 Pƙed rokem +4

    for the first question there is a faster approach , you have to use the sorting more efficiently, there is this O(log n+m ) solution :
    class Solution:
    def searchMatrix(self, matrix: List[List[int]], target: int) -> bool:
    right = len(matrix[0]) -1
    bottom = len(matrix)-1
    top ,left=0,0
    def searchHelper(matrix,top,bottom,left,right,target,visited):
    if top > bottom or left > right:
    return False
    mid1=(top+bottom)//2
    mid2=(left+right)//2
    if (mid1,mid2) in visited :
    return False
    visited.append((mid1,mid2))
    if matrix[mid1][mid2] == target :
    return True
    if matrix[mid1][mid2]>target:
    return searchHelper(matrix,top,bottom,left,mid2-1,target,visited) or searchHelper(matrix,top,mid1-1,left,right,target,visited)
    else:
    return searchHelper(matrix,top,bottom,mid2+1,right,target,visited) or searchHelper(matrix,mid1+1,bottom,left,right,target,visited)

    return searchHelper(matrix,top,bottom,left,right,target,[])

    • @AjaySingh-us1ku
      @AjaySingh-us1ku Pƙed 6 měsĂ­ci

      using recursion is not always a good thing, but yes it can be optimized to 1 more layer using iterative approach.

  • @artemsydorchuk4711
    @artemsydorchuk4711 Pƙed rokem +2

    For the first problem, is the solution with binary search better?
    We can start from the middle in the mattrix, like from the centre of the quadrate and based on the value get rid from all left bottom values or right upper. Than define the middle of new quadrate and repeat a procedure. Time complexty in this case will be O(log(n*m)) which is much better.

  • @ankursharma6084
    @ankursharma6084 Pƙed 2 lety +58

    Nicely explained , both problems are from this month's leetcode daily challange 😃😃

  • @saswatsenapati7870
    @saswatsenapati7870 Pƙed 11 měsĂ­ci

    Great video of the mock.
    Just one highlight point, clarifying questions can be better, for example in triplet question you could have asked do i have to return all the triplets or just one, or what return value is expected the triplet values or its indexes or just a boolean.

  • @dollyyadav3251
    @dollyyadav3251 Pƙed 2 lety +8

    keep doing good work👏👏like each & every video of yours. Amazing content, u r providing a great guidance to each one of us😃

  • @rishabhraj9802
    @rishabhraj9802 Pƙed 2 lety +5

    10:40 @fraz the reason you are giving that you will be able to move in two directions is a assertion not a reason. Reason is you can stand either on four corners or in between the array, inbetween you will have conflicting choices as incrementing row or col will result in bigger values and vice versa but when you start from top right or bottom left you have two non conflicting choices, if you go left you decrease, down increase and vice versa foe other situation

    • @mohammadfraz
      @mohammadfraz  Pƙed 2 lety +2

      Exactly 😊.
      This is the reason why we can only start from top right or bottom left.

    • @rishabhraj9802
      @rishabhraj9802 Pƙed 2 lety

      @@mohammadfraz The way you took it man hats off, shows why you have so many submissions on leetcode.

  • @244_debajitdatta
    @244_debajitdatta Pƙed 2 lety +2

    Max possible min time complexity is
    (Logm+logn)
    If we modify the binary search

  • @stuart3565
    @stuart3565 Pƙed rokem +3

    i really liked this mock interview please upload more video like this it helps to prepare
    bhaiya can i crack the google and microsoft beacuse recently i have started learning dsa from scracth and i am in mid of the 5th sem but i am facing problem while solving questions in optimized way most of the times i watch the solution

  • @piyushmathpal4244
    @piyushmathpal4244 Pƙed 2 lety

    this playlist is best
    Please continue mock interview series

  • @LalitSingh-gu3dt
    @LalitSingh-gu3dt Pƙed 2 lety +3

    inplace of col++ will be col- - And similarly inplace of row-- will be row++

  • @apurbaghosh5540
    @apurbaghosh5540 Pƙed 2 lety +5

    1st ques is asked in my one of interview in my placement session 😍😍

  • @pjagannadham2540
    @pjagannadham2540 Pƙed rokem

    fraz bhaiyya oo first question ka approach is really super and it's easy to understand keep sharing this knowledge bhaiyya

  • @abdussamad0347
    @abdussamad0347 Pƙed 2 lety +17

    I recently practiced both the questions on leetcode. You did it very well. I think in the last question . The duplicates for first loop i.e for i should be the check of arr[i] and arr[i+1]. The for loop itself will handle the last increment.

    • @mohammadfraz
      @mohammadfraz  Pƙed 2 lety +3

      Yes i was doing about to the same after discussing space and time but then we concluded it

    • @poorpanda9033
      @poorpanda9033 Pƙed 9 měsĂ­ci

      Can you send the leetcode link for these questions ?

  • @divine5863
    @divine5863 Pƙed 2 lety +4

    We need more videos like this

  • @tomaraditya9487
    @tomaraditya9487 Pƙed 2 lety +2

    Wow bhaiyaa great video....
    The elements to be unique was the first thing clicked in my mind😇

  • @KushalVijay
    @KushalVijay Pƙed 2 lety +23

    Great conversation with you Fraz, Excited for our next mock interview on my channel. â€ïžđŸ”„

    • @mohammadfraz
      @mohammadfraz  Pƙed 2 lety +4

      Yess đŸ”„ , excited for your turn.

    • @sureshdhakad9854
      @sureshdhakad9854 Pƙed 2 lety +5

      You could have given your detailed feedback at the end of the interview then only it will be helpful for the people who are preparing for interviews.
      Like always ask clarifying question before start discussion the solution.
      I am also taking interviews at my org and find that candidate doesn't ask clarifying questions and also they just jump on coding and doesn't discuss the solution before writing the code.
      These are my expectations as an interviewer:
      1. Candidate should ask clarifying question before discussing the approach to solve the problem.
      2. Candidate should confirm with the interviewer if the approach looks good then only start the coding.
      3. Candidate should think and code loudly so that if he/she get stuck then interviewer can give some hint.
      4. Always try to write optimized code.
      5. Never give up in an interview and seek hint/help if get stuck somewhere. don't seek more than 2 hints.
      6. Consider edge cases and dry run the code with at least 2-3 test cases.

  • @kaustubhshrivastava3169
    @kaustubhshrivastava3169 Pƙed 2 lety +2

    can you get some more medium level questions next time wich are some what harder to solve so that we can get a gist of how to handle the pressure in those situation where we are not getting to the optimal solution btw nice video😀

    • @harshsrivastava2324
      @harshsrivastava2324 Pƙed rokem

      Interviewer questions bnata nahi hai kahi se utha ke hi lata hai except Google

  • @brahmanandakabi8796
    @brahmanandakabi8796 Pƙed rokem

    Thank you bro for this type of content

  • @roydebraj2188
    @roydebraj2188 Pƙed rokem

    its been only a week now of me learning java and i was able to ans the first question i have learnt till arrays and wasnt aware of the concept of binary search i am sure i will learn it in the future. i am writing this message because i am just happy happy hahaha

  • @greatest5902
    @greatest5902 Pƙed 2 lety

    Need more videos in similar format!!

  • @codenchill732
    @codenchill732 Pƙed 2 lety +2

    Keep doing more such interviews

  • @developerDebanjan
    @developerDebanjan Pƙed 2 lety +1

    If only the actual level of the questions would have been like these..

  • @lolwemen
    @lolwemen Pƙed rokem

    ques 1 coptimized approach was actually using binary search, worst case the given by fraz in actually N2 if element is near right corner

  • @dynamichussain1770
    @dynamichussain1770 Pƙed 2 lety +1

    bhaiya for the second question in the 3rd while loop (nums[e]==nums[e+1])it should be e-- instead of e++.

  • @ShinAkuma
    @ShinAkuma Pƙed rokem

    In the first question, why not start at the middle element ?
    The travel distance will always be shortest no matter where your target element lies on the matrix. If you start at the corner and the element lies at the end of the diagonal, you've spent 2X more time than you would have if you started at the middle.

  • @shatadal_das
    @shatadal_das Pƙed 9 měsĂ­ci

    Sir, I solved the first question in O(log (n*m)) complexity by applying Binary search in the last column and Binary Search in the row in which the target may be present.

  • @AJAYKUMAR-pj3zq
    @AJAYKUMAR-pj3zq Pƙed 2 lety +1

    It's great sir please upload this types of video

  • @ritwikshivam1203
    @ritwikshivam1203 Pƙed rokem

    In the first question, it should be col-=1 and row+=1, coz we are coming down to next row if target>current element else 1 col backwards?
    Amazing video btw

  • @kedarkulkarni9464
    @kedarkulkarni9464 Pƙed 2 lety

    I was asked the exact same 1st question for my Microsoft interview :)

  • @gauravgautam5963
    @gauravgautam5963 Pƙed 2 lety

    When we will expect the interview to be taken by you on Kushal vijay's channel that will be to awesome

  • @garigantibhanuvenkatasaikr3164

    very informative

  • @yashnegi9473
    @yashnegi9473 Pƙed rokem

    thank you. It is my dream company to work for. Really appreciate all your efforts sir.

  • @shubamgoswami
    @shubamgoswami Pƙed 2 lety

    ver informative

  • @luckyloops2714
    @luckyloops2714 Pƙed 2 lety

    We can use hashmap with I and j variables sliding through all of them

  • @nandharamya9612
    @nandharamya9612 Pƙed rokem

    If all elements in Matrix is unique then we no need to bother row and column and straightaway we can do binary search tree using a single pointer right. Am I right on this understanding?

  • @surgeonofdeath8199
    @surgeonofdeath8199 Pƙed 2 lety

    In the first question we can apply that 2-d array binary search as well using division and mod as well ..
    Won't that be actually better approach if it is sorted row wise and Column wise both

    • @BROOKnim
      @BROOKnim Pƙed rokem +1

      hmm it won't work without this constraint "every element on one row is greater than the elements on previous rows "
      If this constraint was given , we can consider the 2d array as a 1d array and Bo binary search

    • @gatecsemaster
      @gatecsemaster Pƙed rokem

      this apply when you have the whole matrix is sorted .

  • @siddhantkhare2775
    @siddhantkhare2775 Pƙed 2 lety +63

    Microsoft Engineer using GOOGLE Docs:

    • @shyam_mahadevan
      @shyam_mahadevan Pƙed 8 měsĂ­ci +1

      Document is not important or any paper its about the concept which is required

  • @garigantibhanuvenkatasaikr3164

    very interesting

  • @TheZorboidOrbb
    @TheZorboidOrbb Pƙed rokem +2

    Good video but even before starting with your brute force approach, you should have got some clarifications out of the way. Like
    1. Are all elements positive?
    2. Whole numbers?
    3. Are all elements unique?
    Approaching a solution without getting all the cases and conditions is a strict no. Since this is a mock, you should be very careful in what you teach others.

  • @razataggarwal7365
    @razataggarwal7365 Pƙed 10 měsĂ­ci

    Question 1 can be solved with O(M+N) TC and constant space.

  • @AnkitMishra-ss7mw
    @AnkitMishra-ss7mw Pƙed 6 měsĂ­ci

    Please start with an introduction

  • @PraveenKumar-nu9wk
    @PraveenKumar-nu9wk Pƙed rokem

    Bhaiya in the first problem ie. Find element in sorted matrix ,row and col should be interchanged.

  • @SL4UGHT3R
    @SL4UGHT3R Pƙed rokem

    In first question else statement says row - - which means you are going a row above but that doesn't make any sense. On the other hand where are you checking that target is present or not in that row if column[lastElement]>target.

  • @phoneix24886
    @phoneix24886 Pƙed 2 lety

    The first one could be done in log(m*n). nlog(m) is not optimal.

  • @technicalrafik7034
    @technicalrafik7034 Pƙed 2 lety

    You are doing great work bhaiya Allah Bless You 💯

  • @KalpitSharma
    @KalpitSharma Pƙed rokem

    Easy Question puchha tumne , interview me humko tough ques q aatay hai :( But it really helped a lot to understand how interview should be.

  • @Manoj_Jadhav.12
    @Manoj_Jadhav.12 Pƙed rokem +2

    Man that 3rd approach of first question was đŸ”„đŸ”„

  • @ganapathi2531
    @ganapathi2531 Pƙed 2 lety

    This was good, just a suggestion , it would be good if the input and output is given in docs before explaining the question by the interviewer

    • @mohammadfraz
      @mohammadfraz  Pƙed 2 lety

      Sometimes interviews don't give input or output. But we can always get it clarified

    • @Labrador_Stunts
      @Labrador_Stunts Pƙed rokem

      @@mohammadfraz hi Fraz . Iam new to this .. what is these questions. What kind of coding is this .. is this realated to DSA?

  • @PIYUSH-lz1zq
    @PIYUSH-lz1zq Pƙed 2 lety

    Yeee sahi tha !

  • @Vibedecoded
    @Vibedecoded Pƙed rokem

    Search in a 2d matrix, 3 Sum (leetcode question)

  • @livingwiththedivinesoul8335

    When was it said that the array is going to be sorted in the second question?

  • @subhamdasgupta3848
    @subhamdasgupta3848 Pƙed rokem

    My one liner pythonic solution for question 2,
    [i for i in list(itertools.combinations(list(set(x)), 3)) if sum(list(i)) == k]
    P.S: This solution is only meant for fun.

  • @aamirhannan890
    @aamirhannan890 Pƙed rokem

    Ohh bahi, ye question maine aaj hi kia LeetCode pe!.. logn + logm me ban jaayegi ye binary search se...

  • @gkthecoder9589
    @gkthecoder9589 Pƙed rokem

    can we use a membership check right..!, Weather the element is present or not.

  • @newvideo4033
    @newvideo4033 Pƙed 2 lety

    Plz bhaiya more video upload karo

  • @someshsahu4638
    @someshsahu4638 Pƙed rokem +1

    Nice replica đŸ‘đŸŒ

  • @dsa0decoded
    @dsa0decoded Pƙed 5 měsĂ­ci

    are these to boost confidence or microsoft really ask such easy questions ?

  • @NOTOni
    @NOTOni Pƙed 2 lety

    hi
    you are having a great day TILL NOW ........

  • @AnkurVashishtha01
    @AnkurVashishtha01 Pƙed rokem +1

    Good to see Virat Kohli solving problem. haha jokes aside, amazing content. subbed!

  • @skmdmobinulislam9597
    @skmdmobinulislam9597 Pƙed 2 lety

    Do we have to use google docs in actual interview also?

  • @prettysmart3732
    @prettysmart3732 Pƙed 2 lety +1

    Faraz Sir ye live kro phir bahut acha hoga btw it was great thanks a lot

  • @meetshah31
    @meetshah31 Pƙed 11 měsĂ­ci

    the 1st question is so easy i just solved it in leetcode if i were in the interview im like boom

  • @487_sahilrout3
    @487_sahilrout3 Pƙed 2 lety +1

    Wow agar sachmein is level ka aata hoga microsoft ke interviews pe tab to mera mast se nikal jyega knew both the questions 😄

    • @mohammadfraz
      @mohammadfraz  Pƙed 2 lety +2

      Great đŸ”„ all the best Sahil

    • @sahilrout4745
      @sahilrout4745 Pƙed 2 lety +2

      @@mohammadfraz Thnx bhaiya 🙌 internship season shuru hone wala hai college pe july se need this all the best

  • @notrahul9572
    @notrahul9572 Pƙed měsĂ­cem

    First is not optimal log(m*n) is optimal

  • @ashishverma-gw7cc
    @ashishverma-gw7cc Pƙed 2 lety

    3rd approach will be like,
    Apply BS on 1st column, in log(#col) time we'll have the row where we can expect target element. Then in that row again apply BS to see if element is present or not, log(#col).
    total TC = log(#col) + log(#row) +O(1)

    • @BROOKnim
      @BROOKnim Pƙed rokem

      If you see the question correctly this won't work
      Consider the matrix like this
      [1,3,7]
      [2,4,6]
      [8,9,10]
      And let target be 7
      Here if you apply bs on first column, you'll get the row where ans should be present is third not first ..
      Your approch will be correct if there was this constraint " all the elements on one row is greater than elements from before rows"

  • @iakash017
    @iakash017 Pƙed 2 lety

    thank you so much bhaiya

  • @dhananjaysahu9076
    @dhananjaysahu9076 Pƙed 2 lety +1

    I don't think they will ask these well known questions in off campus interviews

  • @mathematics6199
    @mathematics6199 Pƙed 2 lety +1

    1st question was good

  • @ahmedmukhtar6961
    @ahmedmukhtar6961 Pƙed 2 lety

    I didn't knew they make you write code in microsoft word? i thought we could use normal IDEs.

  • @PROTECHRAHUL
    @PROTECHRAHUL Pƙed 2 lety +1

    Bhaiyaa i was able to solve first question 🙂

  • @saulgoodman6710
    @saulgoodman6710 Pƙed 10 měsĂ­ci

    Wait hows the first q solution correct, he didn't even perform binary search right?

  • @fardeenshaikh6434
    @fardeenshaikh6434 Pƙed 2 lety

    wow bhaiya bhut accha experience diya like real interview

  • @bicky_singhkushwaha228
    @bicky_singhkushwaha228 Pƙed 2 lety

    col-- and row++ instead of col++ and row--

  • @AmitSharma-yi9dr
    @AmitSharma-yi9dr Pƙed 2 lety

    does top companies like microsoft accept candidates with extended education..as in b.tech completed in 6 yrs .

  • @funnygamer4620
    @funnygamer4620 Pƙed rokem

    It should be row++ and else col--

  • @dsadaddy8403
    @dsadaddy8403 Pƙed rokem

    you should have got some dp in the house!

  • @ayajakhtaransari7801
    @ayajakhtaransari7801 Pƙed 2 lety

    Fraz bhaiya plzz bring some podcasts videos also

  • @laluchouhan9163
    @laluchouhan9163 Pƙed rokem

    make a video who take a job from non tech branch

  • @avinashkumar3340
    @avinashkumar3340 Pƙed 9 měsĂ­ci

    This is a cakewalk question. Are Microsoft coding interview questions this easy ?

  • @jayeshnayee6735
    @jayeshnayee6735 Pƙed 2 lety

    Bhaiya online coding platform like gfg,codeshaf, mein code kese likhe, start, end kese kare kuch pata hai nahi chalta, vs code me code likhu too kuch error nahi ati please help me ans please

    • @mohammadfraz
      @mohammadfraz  Pƙed 2 lety

      Easy questions practice karo, usse help milegi kafi

  • @himanshugupta5812
    @himanshugupta5812 Pƙed 2 lety +1

    pls increase your sound your sound was less and interviewer sound was good

    • @mohammadfraz
      @mohammadfraz  Pƙed 2 lety

      It's just because our audio was recorded at his side

  • @sangamsaini138
    @sangamsaini138 Pƙed 2 lety

    sir only this type of quesitons are asked in interview only wow if its my interview i m clear it easly 👍👍

  • @Salesforce_skool
    @Salesforce_skool Pƙed rokem

    It should be col-- and row ++

    • @jude4736
      @jude4736 Pƙed rokem

      Yes ur right , good observation

  • @prabinpanda2882
    @prabinpanda2882 Pƙed 2 lety

    I think row and column variables increments and decrement has been swapped

  • @jude4736
    @jude4736 Pƙed rokem

    Kem Cho faeraz bhai

  • @TheRiddLer870
    @TheRiddLer870 Pƙed 2 lety

    when should i solve your sheet after completely learning dsa or while learning
    it pls reply

  • @sanskrutikanse-fj2rc
    @sanskrutikanse-fj2rc Pƙed rokem

    Hii fraz aapko kitne coding question puche the product based company ke interview mei.can u tell

  • @vishakhas1867
    @vishakhas1867 Pƙed 2 lety

    Its strange in all mock interview first question asked is of matrix, the same one..

  • @mohammadkaifdevalapur
    @mohammadkaifdevalapur Pƙed rokem

    Bhaiya i am stuck in dsa i not understanding how to complete dsa in 1 month

  • @sudheer348Ext
    @sudheer348Ext Pƙed 2 lety

    Good try! Just keep in mind not to come to conclusion or provide a solution in the first minute or 2. take time to clarify and answer all questions and showcase with example before talking about your solution or complexity. just 2 cents!

  • @SachinRao435
    @SachinRao435 Pƙed rokem

    But why you not use a DP in Second Question

  • @kartikkk4583
    @kartikkk4583 Pƙed 2 lety

    ye questions to aapke liye easy honge FRAZ bhaia